package org.nakedobjects.noa.adapter;

import junit.framework.TestCase;


public class ResolveStateTest extends TestCase {

    public static void main(final String[] args) {
        junit.textui.TestRunner.run(ResolveStateTest.class);
    }

    public void testInvalidChangesFromNew() {
        ResolveState from = ResolveState.NEW;
        // assertFalse(from.isValidToChangeTo(ResolveState.GHOST));
        assertFalse(from.isValidToChangeTo(ResolveState.NEW));
        assertFalse(from.isValidToChangeTo(ResolveState.PART_RESOLVED));
        assertFalse(from.isValidToChangeTo(ResolveState.RESOLVED));
        assertFalse(from.isValidToChangeTo(ResolveState.RESOLVING));
        assertFalse(from.isValidToChangeTo(ResolveState.RESOLVING_PART));
        // assertFalse(from.isValidToChangeTo(ResolveState.TRANSIENT));
        assertFalse(from.isValidToChangeTo(ResolveState.DESTROYED));
        assertFalse(from.isValidToChangeTo(ResolveState.UPDATING));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_TRANSIENT));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_GHOST));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_PART_RESOLVED));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_RESOLVED));
    }

    public void testValidChangesFromNew() {
        ResolveState from = ResolveState.NEW;
        assertTrue(from.isValidToChangeTo(ResolveState.GHOST));
        // assertTrue(from.isValidToChangeTo(ResolveState.NEW));
        // assertTrue(from.isValidToChangeTo(ResolveState.PART_RESOLVED));
        // assertTrue(from.isValidToChangeTo(ResolveState.RESOLVED));
        // assertTrue(from.isValidToChangeTo(ResolveState.RESOLVING));
        // assertTrue(from.isValidToChangeTo(ResolveState.RESOLVING_PART));
        assertTrue(from.isValidToChangeTo(ResolveState.TRANSIENT));
        // assertTrue(from.isValidToChangeTo(ResolveState.DESTROYED));
        // assertTrue(from.isValidToChangeTo(ResolveState.UPDATING));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_TRANSIENT));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_GHOST));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_PART_RESOLVED));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_RESOLVED));
    }

    public void testInvalidChangesFromGhost() {
        ResolveState from = ResolveState.GHOST;
        assertFalse(from.isValidToChangeTo(ResolveState.GHOST));
        assertFalse(from.isValidToChangeTo(ResolveState.NEW));
        assertFalse(from.isValidToChangeTo(ResolveState.PART_RESOLVED));
        assertFalse(from.isValidToChangeTo(ResolveState.RESOLVED));
        // assertFalse(from.isValidToChangeTo(ResolveState.RESOLVING));
        // assertFalse(from.isValidToChangeTo(ResolveState.RESOLVING_PART));
        assertFalse(from.isValidToChangeTo(ResolveState.TRANSIENT));
        // assertFalse(from.isValidToChangeTo(ResolveState.DESTROYED));
        // assertFalse(from.isValidToChangeTo(ResolveState.UPDATING));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_TRANSIENT));
        // assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_GHOST));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_PART_RESOLVED));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_RESOLVED));
    }

    public void testValidChangesFromGhost() {
        ResolveState from = ResolveState.GHOST;
        // assertTrue(from.isValidToChangeTo(ResolveState.GHOST));
        // assertTrue(from.isValidToChangeTo(ResolveState.NEW));
        // assertTrue(from.isValidToChangeTo(ResolveState.PART_RESOLVED));
        // assertTrue(from.isValidToChangeTo(ResolveState.RESOLVED));
        assertTrue(from.isValidToChangeTo(ResolveState.RESOLVING));
        assertTrue(from.isValidToChangeTo(ResolveState.RESOLVING_PART));
        // assertTrue(from.isValidToChangeTo(ResolveState.TRANSIENT));
        assertTrue(from.isValidToChangeTo(ResolveState.DESTROYED));
        assertTrue(from.isValidToChangeTo(ResolveState.UPDATING));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_TRANSIENT));
        assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_GHOST));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_PART_RESOLVED));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_RESOLVED));
    }

    public void testInvalidChangesFromTransient() {
        ResolveState from = ResolveState.TRANSIENT;
        assertFalse(from.isValidToChangeTo(ResolveState.GHOST));
        assertFalse(from.isValidToChangeTo(ResolveState.NEW));
        assertFalse(from.isValidToChangeTo(ResolveState.PART_RESOLVED));
        // assertFalse(from.isValidToChangeTo(ResolveState.RESOLVED));
        assertFalse(from.isValidToChangeTo(ResolveState.RESOLVING));
        assertFalse(from.isValidToChangeTo(ResolveState.RESOLVING_PART));
        assertFalse(from.isValidToChangeTo(ResolveState.TRANSIENT));
        assertFalse(from.isValidToChangeTo(ResolveState.DESTROYED));
        assertFalse(from.isValidToChangeTo(ResolveState.UPDATING));
        // assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_TRANSIENT));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_GHOST));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_PART_RESOLVED));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_RESOLVED));
    }

    public void testValidChangesFromTransient() {
        ResolveState from = ResolveState.TRANSIENT;
        // assertTrue(from.isValidToChangeTo(ResolveState.GHOST));
        // assertTrue(from.isValidToChangeTo(ResolveState.NEW));
        // assertTrue(from.isValidToChangeTo(ResolveState.PART_RESOLVED));
        assertTrue(from.isValidToChangeTo(ResolveState.RESOLVED));
        // assertTrue(from.isValidToChangeTo(ResolveState.RESOLVING));
        // assertTrue(from.isValidToChangeTo(ResolveState.RESOLVING_PART));
        // assertTrue(from.isValidToChangeTo(ResolveState.TRANSIENT));
        // assertTrue(from.isValidToChangeTo(ResolveState.DESTROYED));
        // assertTrue(from.isValidToChangeTo(ResolveState.UPDATING));
        assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_TRANSIENT));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_GHOST));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_PART_RESOLVED));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_RESOLVED));
    }

    public void testInvalidChangesFromResolvingPart() {
        ResolveState from = ResolveState.RESOLVING_PART;
        assertFalse(from.isValidToChangeTo(ResolveState.GHOST));
        assertFalse(from.isValidToChangeTo(ResolveState.NEW));
        // assertFalse(from.isValidToChangeTo(ResolveState.PART_RESOLVED));
        // assertFalse(from.isValidToChangeTo(ResolveState.RESOLVED));
        assertFalse(from.isValidToChangeTo(ResolveState.RESOLVING));
        assertFalse(from.isValidToChangeTo(ResolveState.RESOLVING_PART));
        assertFalse(from.isValidToChangeTo(ResolveState.TRANSIENT));
        assertFalse(from.isValidToChangeTo(ResolveState.DESTROYED));
        assertFalse(from.isValidToChangeTo(ResolveState.UPDATING));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_TRANSIENT));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_GHOST));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_PART_RESOLVED));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_RESOLVED));
    }

    public void testValidChangesFromResolvingPart() {
        ResolveState from = ResolveState.RESOLVING_PART;
        // assertTrue(from.isValidToChangeTo(ResolveState.GHOST));
        // assertTrue(from.isValidToChangeTo(ResolveState.NEW));
        assertTrue(from.isValidToChangeTo(ResolveState.PART_RESOLVED));
        assertTrue(from.isValidToChangeTo(ResolveState.RESOLVED));
        // assertTrue(from.isValidToChangeTo(ResolveState.RESOLVING));
        // assertTrue(from.isValidToChangeTo(ResolveState.RESOLVING_PART));
        // assertTrue(from.isValidToChangeTo(ResolveState.TRANSIENT));
        // assertTrue(from.isValidToChangeTo(ResolveState.DESTROYED));
        // assertTrue(from.isValidToChangeTo(ResolveState.UPDATING));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_TRANSIENT));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_GHOST));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_PART_RESOLVED));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_RESOLVED));
    }

    public void testInvalidChangesFromPartResolved() {
        ResolveState from = ResolveState.PART_RESOLVED;
        assertFalse(from.isValidToChangeTo(ResolveState.GHOST));
        assertFalse(from.isValidToChangeTo(ResolveState.NEW));
        assertFalse(from.isValidToChangeTo(ResolveState.PART_RESOLVED));
        assertFalse(from.isValidToChangeTo(ResolveState.RESOLVED));
        // assertFalse(from.isValidToChangeTo(ResolveState.RESOLVING));
        // assertFalse(from.isValidToChangeTo(ResolveState.RESOLVING_PART));
        assertFalse(from.isValidToChangeTo(ResolveState.TRANSIENT));
        // assertFalse(from.isValidToChangeTo(ResolveState.DESTROYED));
        // assertFalse(from.isValidToChangeTo(ResolveState.UPDATING));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_TRANSIENT));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_GHOST));
        // assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_PART_RESOLVED));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_RESOLVED));
    }

    public void testValidChangesFromPartResolved() {
        ResolveState from = ResolveState.PART_RESOLVED;
        // assertTrue(from.isValidToChangeTo(ResolveState.GHOST));
        // assertTrue(from.isValidToChangeTo(ResolveState.NEW));
        // assertTrue(from.isValidToChangeTo(ResolveState.PART_RESOLVED));
        // assertTrue(from.isValidToChangeTo(ResolveState.RESOLVED));
        assertTrue(from.isValidToChangeTo(ResolveState.RESOLVING));
        assertTrue(from.isValidToChangeTo(ResolveState.RESOLVING_PART));
        // assertTrue(from.isValidToChangeTo(ResolveState.TRANSIENT));
        assertTrue(from.isValidToChangeTo(ResolveState.DESTROYED));
        assertTrue(from.isValidToChangeTo(ResolveState.UPDATING));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_TRANSIENT));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_GHOST));
        assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_PART_RESOLVED));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_RESOLVED));
    }

    public void testInvalidChangesFromResolving() {
        ResolveState from = ResolveState.RESOLVING;
        assertFalse(from.isValidToChangeTo(ResolveState.GHOST));
        assertFalse(from.isValidToChangeTo(ResolveState.NEW));
        assertFalse(from.isValidToChangeTo(ResolveState.PART_RESOLVED));
        // assertFalse(from.isValidToChangeTo(ResolveState.RESOLVED));
        assertFalse(from.isValidToChangeTo(ResolveState.RESOLVING));
        assertFalse(from.isValidToChangeTo(ResolveState.RESOLVING_PART));
        assertFalse(from.isValidToChangeTo(ResolveState.TRANSIENT));
        assertFalse(from.isValidToChangeTo(ResolveState.DESTROYED));
        assertFalse(from.isValidToChangeTo(ResolveState.UPDATING));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_TRANSIENT));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_GHOST));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_PART_RESOLVED));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_RESOLVED));
    }

    public void testValidChangesFromResolving() {
        ResolveState from = ResolveState.RESOLVING;
        // assertTrue(from.isValidToChangeTo(ResolveState.GHOST));
        // assertTrue(from.isValidToChangeTo(ResolveState.NEW));
        // assertTrue(from.isValidToChangeTo(ResolveState.PART_RESOLVED));
        assertTrue(from.isValidToChangeTo(ResolveState.RESOLVED));
        // assertTrue(from.isValidToChangeTo(ResolveState.RESOLVING));
        // assertTrue(from.isValidToChangeTo(ResolveState.RESOLVING_PART));
        // assertTrue(from.isValidToChangeTo(ResolveState.TRANSIENT));
        // assertTrue(from.isValidToChangeTo(ResolveState.DESTROYED));
        // assertTrue(from.isValidToChangeTo(ResolveState.UPDATING));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_TRANSIENT));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_GHOST));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_PART_RESOLVED));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_RESOLVED));
    }

    public void testInvalidChangesFromResolved() {
        ResolveState from = ResolveState.RESOLVED;
        // assertFalse(from.isValidToChangeTo(ResolveState.GHOST));
        assertFalse(from.isValidToChangeTo(ResolveState.NEW));
        assertFalse(from.isValidToChangeTo(ResolveState.PART_RESOLVED));
        assertFalse(from.isValidToChangeTo(ResolveState.RESOLVED));
        assertFalse(from.isValidToChangeTo(ResolveState.RESOLVING));
        assertFalse(from.isValidToChangeTo(ResolveState.RESOLVING_PART));
        assertFalse(from.isValidToChangeTo(ResolveState.TRANSIENT));
        // assertFalse(from.isValidToChangeTo(ResolveState.DESTROYED));
        // assertFalse(from.isValidToChangeTo(ResolveState.UPDATING));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_TRANSIENT));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_GHOST));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_PART_RESOLVED));
        // assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_RESOLVED));
    }

    public void testValidChangesFromResolved() {
        ResolveState from = ResolveState.RESOLVED;
        assertTrue(from.isValidToChangeTo(ResolveState.GHOST));
        // assertTrue(from.isValidToChangeTo(ResolveState.NEW));
        // assertTrue(from.isValidToChangeTo(ResolveState.PART_RESOLVED));
        // assertTrue(from.isValidToChangeTo(ResolveState.RESOLVED));
        // assertTrue(from.isValidToChangeTo(ResolveState.RESOLVING));
        // assertTrue(from.isValidToChangeTo(ResolveState.RESOLVING_PART));
        // assertTrue(from.isValidToChangeTo(ResolveState.TRANSIENT));
        assertTrue(from.isValidToChangeTo(ResolveState.DESTROYED));
        assertTrue(from.isValidToChangeTo(ResolveState.UPDATING));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_TRANSIENT));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_GHOST));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_PART_RESOLVED));
        assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_RESOLVED));
    }

    public void testInvalidChangesFromUpdating() {
        ResolveState from = ResolveState.UPDATING;
        assertFalse(from.isValidToChangeTo(ResolveState.GHOST));
        assertFalse(from.isValidToChangeTo(ResolveState.NEW));
        assertFalse(from.isValidToChangeTo(ResolveState.PART_RESOLVED));
        // assertFalse(from.isValidToChangeTo(ResolveState.RESOLVED));
        assertFalse(from.isValidToChangeTo(ResolveState.RESOLVING));
        assertFalse(from.isValidToChangeTo(ResolveState.RESOLVING_PART));
        assertFalse(from.isValidToChangeTo(ResolveState.TRANSIENT));
        assertFalse(from.isValidToChangeTo(ResolveState.DESTROYED));
        assertFalse(from.isValidToChangeTo(ResolveState.UPDATING));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_TRANSIENT));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_GHOST));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_PART_RESOLVED));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_RESOLVED));
    }

    public void testValidChangesFromUpdating() {
        ResolveState from = ResolveState.UPDATING;
        // assertTrue(from.isValidToChangeTo(ResolveState.GHOST));
        // assertTrue(from.isValidToChangeTo(ResolveState.NEW));
        // assertTrue(from.isValidToChangeTo(ResolveState.PART_RESOLVED));
        assertTrue(from.isValidToChangeTo(ResolveState.RESOLVED));
        // assertTrue(from.isValidToChangeTo(ResolveState.RESOLVING));
        // assertTrue(from.isValidToChangeTo(ResolveState.RESOLVING_PART));
        // assertTrue(from.isValidToChangeTo(ResolveState.TRANSIENT));
        // assertTrue(from.isValidToChangeTo(ResolveState.DESTROYED));
        // assertTrue(from.isValidToChangeTo(ResolveState.UPDATING));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_TRANSIENT));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_GHOST));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_PART_RESOLVED));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_RESOLVED));
    }

    public void testInvalidChangesFromSerializingTransient() {
        ResolveState from = ResolveState.SERIALIZING_TRANSIENT;
        assertFalse(from.isValidToChangeTo(ResolveState.GHOST));
        assertFalse(from.isValidToChangeTo(ResolveState.NEW));
        assertFalse(from.isValidToChangeTo(ResolveState.PART_RESOLVED));
        assertFalse(from.isValidToChangeTo(ResolveState.RESOLVED));
        assertFalse(from.isValidToChangeTo(ResolveState.RESOLVING));
        assertFalse(from.isValidToChangeTo(ResolveState.RESOLVING_PART));
        // assertFalse(from.isValidToChangeTo(ResolveState.TRANSIENT));
        assertFalse(from.isValidToChangeTo(ResolveState.DESTROYED));
        assertFalse(from.isValidToChangeTo(ResolveState.UPDATING));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_TRANSIENT));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_GHOST));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_PART_RESOLVED));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_RESOLVED));
    }

    public void testValidChangesFromSerializingTransient() {
        ResolveState from = ResolveState.SERIALIZING_TRANSIENT;
        // assertTrue(from.isValidToChangeTo(ResolveState.GHOST));
        // assertTrue(from.isValidToChangeTo(ResolveState.NEW));
        // assertTrue(from.isValidToChangeTo(ResolveState.PART_RESOLVED));
        // assertTrue(from.isValidToChangeTo(ResolveState.RESOLVED));
        // assertTrue(from.isValidToChangeTo(ResolveState.RESOLVING));
        // assertTrue(from.isValidToChangeTo(ResolveState.RESOLVING_PART));
        assertTrue(from.isValidToChangeTo(ResolveState.TRANSIENT));
        // assertTrue(from.isValidToChangeTo(ResolveState.DESTROYED));
        // assertTrue(from.isValidToChangeTo(ResolveState.UPDATING));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_TRANSIENT));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_GHOST));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_PART_RESOLVED));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_RESOLVED));
    }

    public void testInvalidChangesFromSerializingPartResolved() {
        ResolveState from = ResolveState.SERIALIZING_PART_RESOLVED;
        assertFalse(from.isValidToChangeTo(ResolveState.GHOST));
        assertFalse(from.isValidToChangeTo(ResolveState.NEW));
        // assertFalse(from.isValidToChangeTo(ResolveState.PART_RESOLVED));
        assertFalse(from.isValidToChangeTo(ResolveState.RESOLVED));
        assertFalse(from.isValidToChangeTo(ResolveState.RESOLVING));
        assertFalse(from.isValidToChangeTo(ResolveState.RESOLVING_PART));
        assertFalse(from.isValidToChangeTo(ResolveState.TRANSIENT));
        assertFalse(from.isValidToChangeTo(ResolveState.DESTROYED));
        assertFalse(from.isValidToChangeTo(ResolveState.UPDATING));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_TRANSIENT));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_GHOST));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_PART_RESOLVED));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_RESOLVED));
    }

    public void testValidChangesFromSerializingPartResolved() {
        ResolveState from = ResolveState.SERIALIZING_PART_RESOLVED;
        // assertTrue(from.isValidToChangeTo(ResolveState.GHOST));
        // assertTrue(from.isValidToChangeTo(ResolveState.NEW));
        assertTrue(from.isValidToChangeTo(ResolveState.PART_RESOLVED));
        // assertTrue(from.isValidToChangeTo(ResolveState.RESOLVED));
        // assertTrue(from.isValidToChangeTo(ResolveState.RESOLVING));
        // assertTrue(from.isValidToChangeTo(ResolveState.RESOLVING_PART));
        // assertTrue(from.isValidToChangeTo(ResolveState.TRANSIENT));
        // assertTrue(from.isValidToChangeTo(ResolveState.DESTROYED));
        // assertTrue(from.isValidToChangeTo(ResolveState.UPDATING));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_TRANSIENT));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_GHOST));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_PART_RESOLVED));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_RESOLVED));
    }

    public void testInvalidChangesFromSerializingResolved() {
        ResolveState from = ResolveState.SERIALIZING_RESOLVED;
        assertFalse(from.isValidToChangeTo(ResolveState.GHOST));
        assertFalse(from.isValidToChangeTo(ResolveState.NEW));
        assertFalse(from.isValidToChangeTo(ResolveState.PART_RESOLVED));
        // assertFalse(from.isValidToChangeTo(ResolveState.RESOLVED));
        assertFalse(from.isValidToChangeTo(ResolveState.RESOLVING));
        assertFalse(from.isValidToChangeTo(ResolveState.RESOLVING_PART));
        assertFalse(from.isValidToChangeTo(ResolveState.TRANSIENT));
        assertFalse(from.isValidToChangeTo(ResolveState.DESTROYED));
        assertFalse(from.isValidToChangeTo(ResolveState.UPDATING));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_TRANSIENT));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_GHOST));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_PART_RESOLVED));
        assertFalse(from.isValidToChangeTo(ResolveState.SERIALIZING_RESOLVED));
    }

    public void testValidChangesFromSerializingResolved() {
        ResolveState from = ResolveState.SERIALIZING_RESOLVED;
        // assertTrue(from.isValidToChangeTo(ResolveState.GHOST));
        // assertTrue(from.isValidToChangeTo(ResolveState.NEW));
        // assertTrue(from.isValidToChangeTo(ResolveState.PART_RESOLVED));
        assertTrue(from.isValidToChangeTo(ResolveState.RESOLVED));
        // assertTrue(from.isValidToChangeTo(ResolveState.RESOLVING));
        // assertTrue(from.isValidToChangeTo(ResolveState.RESOLVING_PART));
        // assertTrue(from.isValidToChangeTo(ResolveState.TRANSIENT));
        // assertTrue(from.isValidToChangeTo(ResolveState.DESTROYED));
        // assertTrue(from.isValidToChangeTo(ResolveState.UPDATING));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_TRANSIENT));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_GHOST));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_PART_RESOLVED));
        // assertTrue(from.isValidToChangeTo(ResolveState.SERIALIZING_RESOLVED));
    }

    public void testIsPersistent() {
        assertTrue(ResolveState.RESOLVED.isPersistent());
        assertFalse(ResolveState.TRANSIENT.isPersistent());
        assertTrue(ResolveState.SERIALIZING_RESOLVED.isPersistent());
        assertFalse(ResolveState.SERIALIZING_TRANSIENT.isPersistent());
    }
}
// Copyright (c) Naked Objects Group Ltd.
